Imports System.Threading

Namespace ExpressLane.Concurrency
	''' <summary>
	''' ʾһķίаװ
	''' </summary>
	Friend MustInherit Class DelegateWrapper(Of TReturn)
		''' <summary>
		''' ִίаװίС
		''' </summary>
		Protected MustOverride Function Invoke() As TReturn
		''' <summary>
		''' ίаװתΪίС
		''' </summary>
		Public Function ToDelegate() As Func(Of TReturn)
			Return AddressOf Invoke
		End Function
	End Class
	''' <summary>
	'''  ThreadStart ίнаװ
	''' </summary>
	Friend Class ThreadStartWrapper
		Inherits DelegateWrapper(Of SubroutineReturnType)
		Private m_delegate As ThreadStart
		''' <summary>
		'''  ThreadStart µίаװ
		''' </summary>
		Public Sub New(ByVal proc As ThreadStart)
			m_delegate = proc
		End Sub
		''' <summary>
		''' ִίаװίС
		''' </summary>
		Protected Overrides Function Invoke() As SubroutineReturnType
			m_delegate()
			Return SubroutineReturnType.Value
		End Function
	End Class
	''' <summary>
	'''  ParameterizedThreadStart ίнаװ
	''' </summary>
	Friend Class ParameterizedThreadStartWrapper
		Inherits DelegateWrapper(Of SubroutineReturnType)
		Private m_delegate As ParameterizedThreadStart
		Private m_obj As Object

		''' <summary>
		'''  ParameterizedThreadStart 봫µίаװ
		''' </summary>
		Public Sub New(ByVal proc As ParameterizedThreadStart, ByVal obj As Object)
			m_delegate = proc
			m_obj = obj
		End Sub
		''' <summary>
		''' ִίаװίС
		''' </summary>
		Protected Overrides Function Invoke() As SubroutineReturnType
			m_delegate(m_obj)
			Return SubroutineReturnType.Value
		End Function
	End Class
	''' <summary>
	''' ֻһķίнаװ
	''' </summary>
	Friend Class UnaryFuncWrapper(Of TArg, TReturn)
		Inherits DelegateWrapper(Of TReturn)
		Private m_delegate As Func(Of TArg, TReturn)
		Private m_obj As TArg

		''' <summary>
		'''  Func(Of TArg, TReturn) 봫µίаװ
		''' </summary>
		Public Sub New(ByVal proc As Func(Of TArg, TReturn), ByVal obj As TArg)
			m_delegate = proc
			m_obj = obj
		End Sub
		''' <summary>
		''' ִίаװίС
		''' </summary>
		Protected Overrides Function Invoke() As TReturn
			Return m_delegate(m_obj)
		End Function
	End Class
End Namespace