Namespace ExpressLane.Concurrency
	''' <summary>
	''' 첽ִй̵̳߳ء
	''' </summary>
	Public Interface IExecutor
		''' <summary>
		''' 첽ִһ ThreadStart
		''' </summary>
		Sub Execute(ByVal proc As ThreadStart)
		''' <summary>
		''' 첽ִһ ParameterizedThreadStart
		''' </summary>
		Sub Execute(ByVal proc As ParameterizedThreadStart, ByVal state As Object)
	End Interface
	''' <summary>
	''' ״̬Ƶ첽ִй̵̳߳ء
	''' </summary>
	Public Interface IExecutorLifecycleExtension
		Inherits IExecutor
		''' <summary>
		''' ʾ̳߳صǰ״̬
		''' </summary>
		ReadOnly Property State() As ExecutorState
		''' <summary>
		''' ָһʱȴֱ̳߳ȫֹͣ
		''' </summary>
		Function WaitForAbort(ByVal timeOut As TimeSpan) As Boolean
		''' <summary>
		''' ȴֱ̳߳ȫֹͣ
		''' </summary>
		Sub WaitForAbort()
		''' <summary>
		''' 첽ֹ̳߳ͣ
		''' </summary>
		Sub Abort()

		''' <summary>
		''' 첽ִһ Func(Of TArg, TResult) TResult
		''' </summary>
		Function SubmitTask(Of TArg, TResult)(ByVal proc As Func(Of TArg, TResult), ByVal state As TArg) As IFuture(Of TResult)
		''' <summary>
		''' 첽ִһ޲ Func(Of TResult) TResult
		''' </summary>
		Function SubmitTask(Of TResult)(ByVal proc As Func(Of TResult)) As IFuture(Of TResult)
		''' <summary>
		''' 첽ִһ ThreadStart SubroutineReturnType
		''' </summary>
		Function SubmitTask(ByVal proc As ThreadStart) As IFuture(Of SubroutineReturnType)
		''' <summary>
		''' 첽ִһ ParameterizedThreadStart SubroutineReturnType
		''' </summary>
		Function SubmitTask(ByVal proc As ParameterizedThreadStart, ByVal state As Object) As IFuture(Of SubroutineReturnType)
	End Interface
	''' <summary>
	''' ʾһδɵ
	''' </summary>
	Public Interface IFuture(Of TResult)
		''' <summary>
		''' ȡǰִС
		''' </summary>
		Sub Cancel()
		''' <summary>
		''' ȡǷѱȡ
		''' </summary>
		ReadOnly Property IsCanceled() As Boolean
		''' <summary>
		''' ȡǷɡ
		''' </summary>
		ReadOnly Property IsCompleted() As Boolean
		''' <summary>
		''' ȡڵȴ첽ɵ System.Threading.WaitHandle
		''' </summary>
		ReadOnly Property FutureWaitHandle() As WaitHandle
		''' <summary>
		''' ȴֱɡ
		''' </summary>
		Sub WaitForComplete()
		''' <summary>
		''' ȡڵȴ첽ɵ System.Threading.WaitHandle
		''' </summary>
		Function GetResult() As TResult
	End Interface
	''' <summary>
	''' ָ IExecutorLifecycleExtension ִ״̬
	''' </summary>
	Public Enum ExecutorState
		''' <summary>
		''' IExecutorLifecycleExtension δûйֹ
		''' </summary>
		Running
		''' <summary>
		''' Ѷ̳߳ص IExecutorLifecycleExtension.Abort δյͼֹ
		''' </summary>
		AbortRequested
		''' <summary>
		''' ̳߳ѱΪֹ
		''' </summary>
		Aborted
		''' <summary>
		''' IExecutorLifecycleExtension ѹ
		''' </summary>
		Suspending
		''' <summary>
		'''  IExecutorLifecycleExtension 
		''' </summary>
		SuspendRequested
	End Enum

	''' <summary>
	''' ʾ IExecutorLifecycleExtension ִеģһûв첽ִк
	''' </summary>
	Public Delegate Function Func(Of TResult)() As TResult
	''' <summary>
	''' ʾ IExecutorLifecycleExtension ִеģһв첽ִк
	''' </summary>
	Public Delegate Function Func(Of TArg0, TResult)(ByVal arg0 As TArg0) As TResult
End Namespace